import { EventEmitter } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { FormioResourceConfig } from './resource.config';
import { FormioResources, FormioResourceMap } from './resources.service';
import { FormioLoader } from '../components/loader/formio.loader';
import { FormioAppConfig } from '../formio.config';
import { FormioRefreshValue } from '../formio.common';
import Promise from 'native-promise-only';
export declare class FormioResourceService {
    appConfig: FormioAppConfig;
    config: FormioResourceConfig;
    loader: FormioLoader;
    resourcesService: FormioResources;
    form: any;
    resource: any;
    resourceUrl?: string;
    formUrl: string;
    formFormio: any;
    formio: any;
    onParents: EventEmitter<object[]>;
    onIndexSelect: EventEmitter<object>;
    refresh: EventEmitter<FormioRefreshValue>;
    resourceLoading?: Promise<any>;
    resourceLoaded?: Promise<any>;
    resourceResolve: any;
    resourceReject: any;
    resourceId?: string;
    formLoading?: Promise<any>;
    formLoaded: Promise<any>;
    formResolve: any;
    formReject: any;
    resources: FormioResourceMap;
    constructor(appConfig: FormioAppConfig, config: FormioResourceConfig, loader: FormioLoader, resourcesService: FormioResources);
    initialize(): void;
    onError(error: any): void;
    onFormError(err: any): void;
    loadForm(): any;
    setParents(): void;
    onSubmissionError(err: any): void;
    loadResource(route: ActivatedRoute): any;
    save(resource: any): any;
    remove(): any;
}
